<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2005 Joscha Feth (joscha@feth.com)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'miniFAQ' for the 'cfabwww_minifaq' extension.
 *
 * @author	Joscha Feth <joscha@feth.com>
 */


require_once(PATH_tslib.'class.tslib_pibase.php');

class tx_cfabwwwminifaq_pi1 extends tslib_pibase {
	var $prefixId 		= 'tx_cfabwwwminifaq_pi1';		// Same as class name
	var $scriptRelPath 	= 'pi1/class.tx_cfabwwwminifaq_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey 		= 'cfabwww_minifaq';	// The extension key.
	var $pi_checkCHash 	= TRUE;

	/**
	 * main function, loading plugin conf, setting language key, setting pi var defaults
	 */
	function main($content,$conf)	{
		$this->conf = $conf;		// Setting the TypoScript passed to this function in $this->conf
		$this->setLLkey();
		$this->pi_setPiVarDefaults();

		switch((string)$conf['CMD'])	{
			default:
				if (strstr($this->cObj->currentRecord,'tt_content'))	{
					$this->conf['pidList'] 	= $this->cObj->data['pages'];
					$this->conf['recursive'] 	= $this->cObj->data['recursive'];
				}
				return $this->pi_wrapInBaseClass($this->listView($content));
			break;
		}

	}

	/*
	* sets the language key to use
	* checks firs, if config.language is defined
	* the checks if plugin.tx_cfabwwwminifaq_pi1.language is defined
	* plugin value overrides global config value
	*
	**/
	function setLLkey() {
		$globalLanguage = $GLOBALS['TSFE']->config['config']['language'];
		$pluginLanguage = $this->conf['language'];

		$this->LLkey = $globalLanguage;
		if(!empty($pluginLanguage)) {
			$this->LLkey = $pluginLanguage;
		}
		$this->pi_loadLL(); // Loading the LOCAL_LANG values

	}

	 /**
		* Wrapper for typo3 pi_getLL function. Returns value from local_lang file corresponding to $key.
		*
		* Original Version from CHC Forum, written by Zach Davis
		*
		* @param string $key:  the key in the locallang file to look up.
		* @return string the text from the local_lang file.
		*/
		function lang($key) {
			// You can set the language like this:
			// plugin.tx_cfabwwwminifaq_pi1.language = de (overrides default language conf)
			// or with the global Setup: config.language = de

			return $this->pi_getLL($key);
		}

	/**
	 * [Put your description here]
	 */
	function listView($content)	{
			$lConf = $this->conf['listView.'];	// Local settings for the listView function

			if (!isset($this->piVars['pointer']))	$this->piVars['pointer']=0;
			if (!isset($this->piVars['mode']))	$this->piVars['mode']=1;

				// Initializing the query parameters:
			list($this->internal['orderBy'],$this->internal['descFlag']) = explode(':',$this->piVars['sort']);
			$this->internal['orderByList']='sorting';
			$this->internal['results_at_a_time'] = 1000;
			$this->internal['currentTable'] = 'tx_cfabwwwminifaq_items';

			// Make listing query, pass query to SQL database:
			$res = $this->pi_exec_query($this->internal['currentTable']);
				// Put the whole list together:
			$fullTable='';	// Clear var;
				// Adds the whole list table
			$fullTable.=$this->makelist($res);
				// Returns the content from the plugin.
			return $fullTable;
	}

	/**
	 * [Put your description here]
	 */
	function makelist($res)	{
		$faqs = Array();
		
		$accessibilityPrefix = 'faq_';
		
			// <Jochen Rieger>
		$allowedTags = '';
		$allowedTagsFromTS = Array();
		
		// Transform allowedTags list from TS
		$allowedTagsFromTS = t3lib_div::trimExplode(',', $this->conf['allowedTagsInAnswers']);
		
		foreach ($allowedTagsFromTS as $value) {
			$allowedTags.= '<'.$value.'>';
		}
			// </Jochen Rieger>
		
		//~ fetch rows
		while($this->internal['currentRow'] = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{
			$faqs[]= array(	'question' 	=> htmlspecialchars($this->getFieldContent('f_question')),
							'answer'	=> strip_tags($this->getFieldContent('f_answer'), $allowedTags), // <Jochen Rieger: strip tags according to allowedTags />
							'uid'		=> $this->getFieldContent('uid'),
							'linkHash'	=> $accessibilityPrefix.md5($this->getFieldContent('uid')));
		}
		// <Jochen Rieger: added 'faq' for accessibility in anchors />
		$tlinkhash = $accessibilityPrefix.md5((string) microtime()); 

		//~ add questions
		$out = '<a name="'.$tlinkhash.'"></a><div'.$this->pi_classParam('questions').'>
					<ol>';
					// <Jochen Rieger: Added title attribute for accessibility /> 
					foreach($faqs AS $faq) {
						$out .= '<li><a href="#'.$faq['linkHash'].'" title="'.$faq['question'].'">'.$faq['question'].'</a></li>';
					}
		$out .= 	'</ol>
				</div>';

		//~ and the answers...

			$out .= '<ol'.$this->pi_classParam('answers').'>';

				foreach($faqs AS $faq) {
					$out .= '<li'.$this->pi_classParam('q-a-package').'><a name="'.$faq['linkHash'].'"></a>
								<p'.$this->pi_classParam('q').'>'.$faq['question'].'</p>';
					$out .= 	'<blockquote'.$this->pi_classParam('a').'>'.$faq['answer'].'</blockquote>';


					if(!$this->conf['noToplink']) {
						$out .=	'<a href="#'.$tlinkhash.'" '.$this->pi_classParam('toplink').'>'.$this->lang('toTopLinkName').'</a>';
					}
					$out .= 	'<hr />
							</li>';
				}

		$out .= '</ol>';
		return $out;
	}

	/**
	 * [Put your description here]
	 */
	function getFieldContent($fN)	{
		switch($fN) {
			case "f_answer":
				return $this->pi_RTEcssText($this->internal['currentRow']['f_answer']);
			break;

			default:
				return $this->internal['currentRow'][$fN];
			break;
		}
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cfabwww_minifaq/pi1/class.tx_cfabwwwminifaq_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cfabwww_minifaq/pi1/class.tx_cfabwwwminifaq_pi1.php']);
}
?>
